import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.ContentType;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.HttpClientBuilder;
import org.apache.http.util.EntityUtils;

public class Request {

    private HttpClient conn = HttpClientBuilder.create().build();
    private int responseCode = 0;

    public Request(){

    }

    public boolean post(String url, String data){
        try {
            StringEntity requestEntity = new StringEntity(data, ContentType.APPLICATION_JSON);
            HttpPost postMethod = new HttpPost(url);
            postMethod.setEntity(requestEntity);

            HttpResponse rawResponse = conn.execute(postMethod);
            responseCode = rawResponse.getStatusLine().getStatusCode();
            if(responseCode == 200){
                return true;
            }
        }catch(Exception e){ }
        return false;
    }

    public String get(String url){
        try {
            HttpGet getMethod = new HttpGet(url);
            HttpResponse rawResponse = conn.execute(getMethod);
            responseCode = rawResponse.getStatusLine().getStatusCode();
            if (responseCode == 200) {
                HttpEntity entity = rawResponse.getEntity();
                String responseString = EntityUtils.toString(entity, "UTF-8");
                return responseString;
            }
        }catch(Exception e){ }
        return null;
    }

    public int getResponseCode() {
        return responseCode;
    }
}
