import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.List;

public class YouAreEll {

    private Request requestHandler = new Request();

    YouAreEll() {
    }

    public static void main(String[] args) {
        YouAreEll urlhandler = new YouAreEll();
        System.out.println(urlhandler.MakeURLCall("/ids", "GET", ""));
        System.out.println(urlhandler.MakeURLCall("/messages", "GET", ""));
    }

    public String get_ids() {
        String JSON =  MakeURLCall("/ids", "GET", "");
        printUsers(JSON);
        return JSON;
    }

    public String get_messages() {
        String JSON =  MakeURLCall("/messages", "GET", "");
        printMessages(JSON);
        return JSON;
    }

    public String MakeURLCall(String mainurl, String method, String jpayload) {
        switch(method) {
            case "GET":
                return requestHandler.get("http://zipcode.rocks:8085" + mainurl);

            case "POST":
                if(requestHandler.post("http://zipcode.rocks:8085" + mainurl, jpayload)){
                    return "completed";
                }
                return "incomplete";
        }
        return null;
    }




    public void registerUser(String command){
        String[] parts = command.split(" ");
        if(parts.length != 3){
            System.out.println("\nTo register, please use \"register [name] [github username]\"");
        } else {
            String name = parts[1];
            String username = parts[2];
            if(MakeURLCall("/ids", "POST", getIdJSON(name, username)).equals("completed")){
                System.out.println("\nUser created: " + username);
            }
        }
    }

    public String getIdJSON(String name, String username){
        Gson gson = new Gson();
        String userJSON = gson.toJson(new User(name, username));
        return userJSON;
    }

    public void printUsers(String json){
        listUsers(getUserList(json));
    }

    public List<User> getUserList(String JSON){
        Gson gson = new Gson();
        Type listType = new TypeToken<List<User>>(){}.getType();
        return gson.fromJson(JSON, listType);
    }

    public void listUsers(List<User> users){
        users.forEach(u -> {
            System.out.printf("\n%-20s %-20s %-20s", u.getName(), u.getGithub(), u.getUserid());
        });
    }

    public void printMessages(String JSON){
        listMessages(getMessageList(JSON));
    }

    public List<Message> getMessageList(String JSON){
        Gson gson = new Gson();
        Type listType = new TypeToken<List<Message>>(){}.getType();
        return gson.fromJson(JSON, listType);
    }

    public void listMessages(List<Message> messages){
        messages.forEach(m -> {
            System.out.printf("\n Time: %-20s From: %-20s To:  %-20s Message: %-50s", m.getTimestamp() + ",", m.getFromid() + ",", m.getToid() + ",", m.getMessage() + ",");
        });
    }
}
